/***********************************************************************\
 * MakePrg.cmd  Installation batch file.                               *
 *                                                                     *
 *              MakePrg <InstallationPathDirectory>                    *
 *              F.e. MakePrg C:\OS2\DSPINSTL                           *
 *                                                                     *
\***********************************************************************/

Start.File="*.EXE"
'@echo off'

                                        /* Register REXX APIs */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

call RxFuncAdd 'VInit', 'VREXX', 'VINIT'
initcode = VInit()
if initcode = 'ERROR' then signal CleanUp

signal on failure name CleanUp
signal on halt name CleanUp
signal on syntax name CleanUp


Parse Arg ObjectFileName                /* Get the path and filename of a file to be
                                           installed as a WPS Object with a defined
                                           Object ID, that can directly be installed
                                           to PC/2 */
                                        /* Search if this file exists once */
If ObjectFileName\=" " Then Do
    Rc=SysFileTree(ObjectFileName, FileExistFlag, 'FO')
    If Rc\=0 Then do                    /* Any error is a fatal memory problem */
        call VdialogPos 50, 50
        mbox.0 = 1
        mbox.1 = "   A fatal memory error ocured."
        call VMsgBox "Error", mbox, 1
        signal CleanUp
    end
                                         /* If 1 file existed get it otherwise reinput */
    If FileExistFlag.0\=1 Then do
        call VdialogPos 50, 50
        mbox.0 = 1
        mbox.1 = "   Many file is selected."
        call VMsgBox "Error", mbox, 1
        signal CleanUp
    end
    else
        NewObjectFileName=FileExistFlag.1
                                            /* Extract filename from path & filename */
    NewObjectName=FILESPEC("Name", NewObjectFileName)
                                            /* Extract path from path & filename */
    NewObjectPath=LEFT(NewObjectFileName, LASTPOS('\', NewObjectFileName)-1)
                                            /* Dismiss extension from filename */
    NewObject=LEFT(NewObjectName, LASTPOS('.', NewObjectName)-1)

    parse upper value NewObjectName with Temp "." Extension
/*    select
        when Extension="EXE" then nop
        when Extension="COM" then nop
        when Extension="BAT" then nop
        when Extension="CMD" then nop
        otherwise
            signal CleanUp
    end*/
    if (Extension\="EXE") & (Extension\="COM") & (Extension\="BAT") & (Extension\="CMD") then do
        call VdialogPos 50, 50
        mbox.0 = 1
        mbox.1 = "   Select File is not Excutuble."
        call VMsgBox "Error", mbox, 1
        signal CleanUp
    end

                                            /* Assign filename without extension between <WP_ and > */
    NewObjectID="<WP_"NewObject">"
                                            /* Setup the WPS Object configuration */
    SetupString="OBJECTID="NewObjectID";STARTUPDIR="NewObjectPath";EXENAME="NewObjectFileName";"
                                            /*'PROGTYPE='exetype';'||,'OPEN=DEFAULT;'||,*/
                                            /* could be added or not */
                                            /* Now create the WPS Object on the Desktop */
    rc=SysCreateObject("WPProgram",,
                       NewObjectID,,        /* It should be NewObject, if I knew how to add the Object
                                               rendering mechanism to the filename rendering mechanism
                                               to PC/2's Drag & Drop support */
                       "<WP_MAIN>",,
                       SetupString)

    if rc=0 then do
        call VdialogPos 50, 50
        mbox.0 = 1
        mbox.1 = "   This file is existed."
        call VMsgBox "Error", mbox, 1
    end
    signal CleanUp
End

    Start.Dir = directory()

Do While 1=1
    call VDialogPos 40, 50
    button = VFileBox('Select a file...', Start.Dir"\"Start.File, 'file')
    if button = 'CANCEL' then
        signal CleanUp
    NewObjectFileName = file.vstring

                                            /* Extract filename from path & filename */
    NewObjectName=FILESPEC("Name", NewObjectFileName)
                                            /* Extract path from path & filename */
    NewObjectPath=LEFT(NewObjectFileName, LASTPOS('\', NewObjectFileName)-1)
                                            /* Dismiss extension from filename */
    NewObject=LEFT(NewObjectName, LASTPOS('.', NewObjectName)-1)

    parse upper value NewObjectName with Temp "." Extension
/*    select
        when Extension="EXE" then nop
        when Extension="COM" then nop
        when Extension="BAT" then nop
        when Extension="CMD" then nop
        otherwise
            signal CleanUp
    end*/
    if (Extension\="EXE") & (Extension\="COM") & (Extension\="BAT") & (Extension\="CMD") then do
        call VdialogPos 50, 50
        mbox.0 = 1
        mbox.1 = "   Select File is not Excutuble."
        call VMsgBox "Error", mbox, 1
    end
    else do
        Start.dir=NewObjectPath
        Start.File="*"RIGHT(NewObjectName,4)
                                            /* Assign filename without extension between <WP_ and > */
        NewObjectID="<WP_"NewObject">"
                                            /* Setup the WPS Object configuration */
        SetupString="OBJECTID="NewObjectID";STARTUPDIR="NewObjectPath";EXENAME="NewObjectFileName";"
                                            /*'PROGTYPE='exetype';'||,'OPEN=DEFAULT;'||,*/
                                            /* could be added or not */
                                            /* Now create the WPS Object on the Desktop */
        rc=SysCreateObject("WPProgram",,
                       NewObjectID,,        /* It should be NewObject, if I knew how to add the Object
                                               rendering mechanism to the filename rendering mechanism
                                               to PC/2's Drag & Drop support */
                       "<WP_MAIN>",,
                       SetupString)

        if rc=0 then do
            call VdialogPos 50, 50
            mbox.0 = 1
            mbox.1 = "   This file is existed."
            call VMsgBox "Error", mbox, 1
        end /* end if rc=0 then */
    end  /* end else do */
End  /* end do while 1=1 */

CleanUp:
Call vExit
Exit

